#ifndef __BIFUNCS__
#define __BIFUNCS__

/* Common Includes */
#include <glib.h>
#include <stdarg.h>
#include <stdlib.h>

#include <math.h>


#define complex_missing_error(function) nxp_eval_error(\
  "Function " function " does not support complex numbers because <complex.h> was not found.")


/* This include does not work at the top, I don't know why! 
   Well... or I did know, but I can't remember...*/
#include "element.h"
#include "variables.h"

/* bifuncs.c --------------------------------------------------------- */
GCompletion* nxp_bifunc_initialize      (void);
NxpElement*  nxp_function_call_x        (char           *name,
					 ...);
NxpElement*  nxp_bifunc_derive_constant (NxpIdentifier  *ident,
					 GSList         *args);

#define elem_FUNC_CALL(name, arg1) ({NxpElement *x1 = NXP_ELEMENT(arg1), *r = nxp_function_call_x(name, x1, NULL); NXP_ELEMENT_UNREF(x1); r; })

#define elem_FUNC_CALL2(name, arg1, arg2) ({NxpElement *x1 = NXP_ELEMENT(arg1), *x2 = NXP_ELEMENT(arg2), *r = nxp_function_call_x(name, x1, x2, NULL); NXP_ELEMENT_UNREF(x1); NXP_ELEMENT_UNREF(x2); r; })

#define elem_FUNC_CALL3(name, arg1, arg2, arg3) ({NxpElement *x1 = NXP_ELEMENT(arg1), *x2 = NXP_ELEMENT(arg2), *x3 = NXP_ELEMENT(arg3), *r = nxp_function_call_x(name, x1, x2, x3, NULL); NXP_ELEMENT_UNREF(x1); NXP_ELEMENT_UNREF(x2); NXP_ELEMENT_UNREF(x3); r; })

#define elem_FUNC_CALL4(name, arg1, arg2, arg3, arg4) ({NxpElement *x1 = NXP_ELEMENT(arg1), *x2 = NXP_ELEMENT(arg2), *x3 = NXP_ELEMENT(arg3), *x4 = NXP_ELEMENT(arg4), *r = nxp_function_call_x(name, x1, x2, x3, x4, NULL); NXP_ELEMENT_UNREF(x1); NXP_ELEMENT_UNREF(x2); NXP_ELEMENT_UNREF(x3); NXP_ELEMENT_UNREF(x4); r; })
 

/* Some macros */ 
#define elem_SIN(a)     elem_FUNC_CALL("sin", a) 
#define elem_COS(a)     elem_FUNC_CALL("cos", a) 
#define elem_TG(a)      elem_FUNC_CALL("tg", a) 
#define elem_COTG(a)    elem_FUNC_CALL("cotg", a) 

#define elem_SINH(a)    elem_FUNC_CALL("sinh", a) 
#define elem_COSH(a)    elem_FUNC_CALL("cosh", a) 
#define elem_TGH(a)     elem_FUNC_CALL("tgh", a) 
#define elem_COTGH(a)   elem_FUNC_CALL("cotgh", a) 

#define elem_SECH(a)    elem_FUNC_CALL("sech", a) 
#define elem_COSECH(a)  elem_FUNC_CALL("cosech", a)
#define elem_SEC(a)     elem_FUNC_CALL("sec", a)
#define elem_COSEC(a)   elem_FUNC_CALL("cosec", a)

#define elem_ARCSIN(a)  elem_FUNC_CALL("arcsin", a)
#define elem_ARCCOS(a)  elem_FUNC_CALL("arccos",a)
#define elem_ARCTG(a)   elem_FUNC_CALL("arctg", a) 
#define elem_ARCCOTG(a) elem_FUNC_CALL("arccotg", a) 

#define elem_ARCSINH(a)  elem_FUNC_CALL("arcsinh", a)
#define elem_ARCCOSH(a)  elem_FUNC_CALL("arccosh", a) 
#define elem_ARCTGH(a)   elem_FUNC_CALL("arctgh", a) 
#define elem_ARCCOTGH(a) elem_FUNC_CALL("arccotgh", a) 

 
/* Some macros */ 
#define elem_LOG(a)  elem_FUNC_CALL("log", a) 
#define elem_LN(a)   elem_FUNC_CALL("ln", a) 
#define elem_SQRT(a) elem_FUNC_CALL("sqrt", a) 
#define elem_EXP(a)  elem_FUNC_CALL("exp", a) 

 
/* Some macros */ 
#define elem_IM(a)   elem_FUNC_CALL("imag", a) 
#define elem_ABS(a)  elem_FUNC_CALL("abs", a) 
#define elem_ARG(a)  elem_FUNC_CALL("arg", a) 
#define elem_RE(a)   elem_FUNC_CALL("real", a) 



/* Some macros */ 
#define elem_IF_THEN(a,b)           elem_FUNC_CALL2("if" ,a,b) 
#define elem_IF_THEN_ELSE(a,b,c)    elem_FUNC_CALL3("if" ,a,b,c) 
//#define elem_FACTORIAL(a)           elem_FUNC_CALL("factorial",a) 
#define elem_GET_FROM_MATRIX(a,b,c) elem_FUNC_CALL3("getFromMatrix",a,b,c)
#define elem_GET_FROM_VECTOR(a,b)   elem_FUNC_CALL2("getFromVector",a,b)

#define elem_REPLACE_ON_VECTOR(a,b,c)   elem_FUNC_CALL3("replaceOnVector",a,b,c)
#define elem_REPLACE_ON_MATRIX(a,b,c,d) elem_FUNC_CALL4("replaceOnMatrix",a,b,c,d)
#define elem_VECTOR_FILL(a, b)	elem_FUNC_CALL2("vectorFill", a, b)
#define elem_SIZE(a) elem_FUNC_CALL("size", a)



#endif





