/* -*- Mode: C; c-file-style: "stroustrup"; -*- */
#ifndef __ELEMENT_CONTEXT_H__
#define __ELEMENT_CONTEXT_H__

typedef struct _NxpEvalContext	NxpEvalContext;
typedef NxpEvalContext NxpContext;

#include "element.h"
#include "namespace.h"


typedef enum {
    NXP_MESSAGE_PRINT,
    NXP_MESSAGE_PARSER_WARNING,
    NXP_MESSAGE_EVAL_WARNING
} NxpMessageType;

typedef void (*NxpOutputHandler) (const gchar    *msg,
				  NxpMessageType  msg_type,
				  NxpEvalContext *context);

struct _NxpEvalContext {
    /*< private > */
    NxpNameSpace *first_anonymous_name_space;
    GSList       *monitored_namespaces;

    NxpNameSpace *root_name_space;

    /*< public >*/
    NxpNameSpace *cwd;	/* global definition's namespace (current
                           working directory) */
    GHashTable   *data;
    NxpOutputHandler output_handler;
};


void            nxp_eval_context_set_user_data   (NxpEvalContext *self,
						  const char     *dataname,
						  gpointer        data);
gpointer        nxp_eval_context_get_user_data   (NxpEvalContext *self,
						  const char     *dataname);
NxpEvalContext* nxp_eval_context_new             (const char     *rcfile);
void            nxp_eval_context_destroy         (NxpEvalContext *self);
void            nxp_eval_context_push_name_space (NxpEvalContext *self);
void            nxp_eval_context_pop_name_space  (NxpEvalContext *self);


#endif /* #ifndef __ELEMENT_CONTEXT_H__ */
