#ifndef __NXP_IDENTIFIER_H__
#define __NXP_IDENTIFIER_H__

#include <glib.h>


#define nxp_root_name_space nxp_global_name_space

/* --- forward declarations --- */

/* in element.h */
/*  typedef struct _NxpIdentifier 		NxpIdentifier; */


/* --- includes --- */
#include "namespace.h"

#define NXP_ID_2(a,b)  nxp_identifier_new_with_full_path (2,a,b)



extern volatile int nxp_identifier_global_count;


/* --- function prototypes --- */
NxpIdentifier* nxp_identifier_new                        (void);
NxpIdentifier* nxp_identifier_new_simple                 (const char      *name);
NxpIdentifier* nxp_identifier_new_with_full_path         (int              levels,
							  ...);
NxpIdentifier* nxp_identifier_ref                        (NxpIdentifier   *self);
NxpIdentifier* nxp_identifier_unref                      (NxpIdentifier   *self);
void           nxp_identifier_append_component           (NxpIdentifier   *self,
							  const char      *component);
void           nxp_identifier_append_separator           (NxpIdentifier   *self);
void           nxp_identifier_prepend_separator           (NxpIdentifier   *self);
void           nxp_identifier_resolve                    (NxpIdentifier   *self,
							  NxpEvalContext  *context,
							  NxpNameSpace   **ns_ptr,
							  const char     **name_ptr);
void           nxp_identifier_resolve_from_dir           (NxpIdentifier   *self,
							  NxpNameSpace    *cwd,
							  NxpNameSpace   **ns_ptr,
							  const char     **name_ptr,
							  NxpEvalContext  *context);
gboolean       nxp_identifier_equal                      (NxpIdentifier   *a,
							  NxpIdentifier   *b,
							  NxpEvalContext  *context);
gboolean       nxp_identifier_is_relative                (NxpIdentifier   *self);
gboolean       nxp_identifier_is_dir                     (NxpIdentifier   *self);
const char*    nxp_identifier_to_function_argument       (NxpIdentifier   *self);
NxpDefinition* nxp_identifier_to_function_definition     (NxpIdentifier   *self,
							  NxpEvalContext  *context,
							  int              arity,
							  char           **fullname);
NxpIdentifier* nxp_identifier_create_function_identifier (NxpIdentifier   *base,
							  int              arity);
GString*       nxp_identifier_to_gstring                 (NxpIdentifier   *self);
char*          nxp_identifier_to_string                  (NxpIdentifier   *self);
void           nxp_identifier_debug_print                (NxpIdentifier   *self,
							  const char      *message_prefix);
gboolean       nxp_identifier_is_plain                   (NxpIdentifier   *self);
NxpIdentifier* nxp_identifier_from_string                (const char      *path,
							  NxpEvalContext  *context,
							  GError         **error);

#endif
