/* -*- Mode: C; c-file-style: "bsd"; -*- */

/* nxp_kernel.h -- a frontend to the numexp kernel library */

#ifndef __NXP_KERNEL_H__
#define __NXP_KERNEL_H__

#include "errors.h"
#include "module.h"
#include "message.h"
#include "bifuncs.h"
#include "element.h"
#include "typecasts.h"
#include "namespace.h"
#include "variables.h"
#include "prototypes.h"
#include "identifier.h"
#include "op_bindings.h"
#include "element_output.h"
#include "nxp_debug.h"

#include "types/types.h"
#include "parser/files.h"

#define ETC           GHashTable *named_args, NxpEvalContext *context, GError **error
#define ETC_DELEGATE  named_args, context, error
#define SIMPLE_ETC    NxpEvalContext *context, GError **error
#define SIMPLE_ETC_DELEGATE context, error


void  nxp_kernel_init(void);
void  nxp_kernel_load_rc(const char *rcfile, NxpEvalContext *context);
char* nxp_kernel_version(void);

#endif /* __NXP_KERNEL_H__ */
