#ifndef __EXP_PARSER_H__
#define __EXP_PARSER_H__

#include <stdio.h>
#include "element.h"
#include "eval_context.h"


#define ParseString exp_parse_string
//#define root_name_space global_name_space

typedef struct _NxpArg NxpArg;

struct _NxpArg {
    NxpElement *list;
    GHashTable *named_arg;
};


/* the prefix for this module is 'exp', not 'exp_parser'  */

extern char 	*exp_input;
extern char 	*exp_inputptr;
extern int 	 exp_inputlim;
extern NxpElement 	*exp_expression;
extern gint 	 expdebug;


/* GError stuff */
#define EXP_PARSE_ERROR_DOMAIN exp_parse_error_quark ()
GQuark exp_parse_error_quark (void) G_GNUC_CONST;

typedef enum
{
  EXP_PARSE_ERROR
} ExpParseError;



/* Use this to report errors when parsing expressions */
void nxp_parser_error   (const char *format, ...) G_GNUC_PRINTF(1, 2);

/* Use this to report warnings when parsing expressions */
void nxp_parser_warning (const char *format, ...) G_GNUC_PRINTF(1, 2);



NxpElement* exp_parse_string (const gchar     *expr,
			      NxpEvalContext  *context,
			      GError         **error);
void        exp_parser_init  (void);


/*
  This is a prototype for the flex/bison error handling function.
*/
/* These are private functions */
int         explex           (void);
void        experror         (char          *s);
void        exprestart       (FILE          *input_file);
int         expparse         (void);
int         exp_yyinput      (char          *buf,
			      int            max_size);
void        expunput         (int            c,
			      register char *yy_bp);

/* These are deprecated functions */
#define ParseExpression(entry) (exp_parse_string(gtk_entry_get_text(GTK_ENTRY(entry)))? 1:0)
#define parsefloat exp_parse_string


#endif

