#ifndef __NXP_PARSER_PLUGINS_H__
#define __NXP_PARSER_PLUGINS_H__

#include "element.h"

typedef NxpElement* (*NxpAtomParserFunc)(const gchar *string);

typedef struct {
  NxpAtomParserFunc func;
  int priority;
} NxpAtomParser;



typedef enum {
  NXP_ATOM_CLASS_INT,
  NXP_ATOM_CLASS_REAL,
  NXP_ATOM_CLASS_COMPLEX,
  NXP_ATOM_CLASS_STRING,
  NXP_ATOM_CLASS_FRAC
} NxpAtomClass;

NxpElement* nxp_parser_try_parse     (NxpAtomClass       klass,
				      const gchar       *string);
void        nxp_parser_init          (void);
void        nxp_parser_register_func (NxpAtomClass       klass,
				      NxpAtomParserFunc  function,
				      int                priority);



#endif
