#ifndef __NXPINTPOLY_MOD_H__
#define __NXPINTPOLY_MOD_H__

#include "nxpintpoly.h"

void nxp_int_poly_normalize			    (NxpIntPoly *r,
						     NxpIntPoly *a, mpz_t n);
void nxp_int_poly_normalize1			    (NxpIntPoly *r,
						     NxpIntPoly *a, mpz_t n);
void nxp_int_poly_normalize_ui			    (NxpIntPoly *r,
						     NxpIntPoly *a, guint n);
void nxp_int_poly_power_mod			    (NxpIntPoly *ret,
						     NxpIntPoly *a,
						     nxp_int_t n,
						     nxp_int_t p);
void nxp_int_poly_gcdext_mod			    (NxpIntPoly *r,
						     NxpIntPoly *u,
						     NxpIntPoly *v,
						     NxpIntPoly *a,
						     NxpIntPoly *b,
						     mpz_t p);
void nxp_int_poly_gcd_mod			    (NxpIntPoly *r,
						     NxpIntPoly *a,
						     NxpIntPoly *b,
						     mpz_t p);
void nxp_int_poly_div_qr_mod			    (NxpIntPoly *q, NxpIntPoly *r,
						     NxpIntPoly *u, NxpIntPoly *v,
						     mpz_t p);
void nxp_int_poly_div_q_mod			    (NxpIntPoly *q, NxpIntPoly *u,
						     NxpIntPoly *v, mpz_t p);
void nxp_int_poly_div_r_mod			    (NxpIntPoly *r, NxpIntPoly *u,
						     NxpIntPoly *v, mpz_t p);
void nxp_int_poly_hensel_quad			    (NxpIntPoly *a1,
						     NxpIntPoly *b1,
						     NxpIntPoly *pol,
						     NxpIntPoly *a,
						     NxpIntPoly *b,
						     mpz_t p, int e);
void nxp_int_poly_hensel_linear			    (NxpIntPoly *a1,
						     NxpIntPoly *b1,
						     NxpIntPoly *pol,
						     NxpIntPoly *a,
						     NxpIntPoly *b,
						     mpz_t p, int e);
void nxp_int_poly_hensel_array			    (NxpIntPoly *pol,
						     GArray *array, mpz_t p,
						     int e);
GSList *nxp_int_poly_ddf			    (NxpIntPoly *a,
						     mpz_t p);
GSList *nxp_int_poly_get_factors		    (NxpIntPoly *pol,
						     GSList *list, mpz_t p);
#endif /* __NXPINTPOLY_MOD_H__ */
