#ifndef __CONTAINER_H__
#define __CONTAINER_H__

#include "element.h"

typedef struct _NxpElementContainer	NxpElementContainer;

#define NXP_ELEMENT_TYPE_CONTAINER	(nxp_element_container_get_type())
#define NXP_ELEMENT_CONTAINER(x)	(NXP_ELEMENT_TYPECAST(x, NXP_ELEMENT_TYPE_CONTAINER,	NxpElementContainer	))
#define NXP_ELEMENT_IS_CONTAINER(x)	        nxp_element_check_type((x), NXP_ELEMENT_TYPE_CONTAINER)

/* A NxpElementContainer is a NumExp element that points to a particular element of a vector. parent points to the vector and el is this particular element. */
struct _NxpElementContainer {
    NxpElement   element;
    NxpElement	*parent;
    NxpElement	*index;
};

int	    nxp_element_container_get_type	(void);
void        nxp_element_container_type_init();
NxpElement* nxp_element_container_new(NxpElement *parent, NxpElement *index);
#endif
