#ifndef __NXP_FRAC_H__
#define __NXP_FRAC_H__
#include <gmp.h>
#include <mpfr.h>
#include "r.h"

#define NXP_ELEMENT_TYPE_FRAC	(nxp_element_frac_get_type())

typedef struct _NxpElementFrac 	NxpElementFrac;

#define NXP_ELEMENT_FRAC(x)		(NXP_ELEMENT_TYPECAST(x, NXP_ELEMENT_TYPE_FRAC, NxpElementFrac	))
#define NXP_ELEMENT_IS_FRAC(x)	        nxp_element_check_type(NXP_ELEMENT(x), NXP_ELEMENT_TYPE_FRAC)

struct _NxpElementFrac {
    NxpElementR element;
    mpq_t	value;
};

int nxp_element_frac_get_type(void);
void        nxp_element_frac_type_init      ();
void	    nxp_element_frac_operator_init  (NxpEvalContext  *context,
					     GError	    **error);
NxpElement* nxp_element_frac_new            (nxp_int_t        a,
					     nxp_int_t        b);
NxpElement* nxp_element_frac_new_from_mpq   (mpq_t	      value);
NxpElement* nxp_element_frac_get_num(NxpElement *el);
NxpElement* nxp_element_frac_get_den(NxpElement *el);

#endif /* __NXP_FRAC_H__ */
