/* -*- Mode: C; c-file-style: "stroustrup"; -*- */
#ifndef __FUNCTION_H__
#define __FUNCTION_H__

#include "variable.h"
#include "list.h"

typedef struct _NxpElementFunction	NxpElementFunction;

#include "element.h"

#define NXP_ELEMENT_TYPE_FUNCTION   (nxp_element_function_get_type())
#define NXP_ELEMENT_FUNCTION(x)		(NXP_ELEMENT_TYPECAST(x, NXP_ELEMENT_TYPE_FUNCTION,	NxpElementFunction	))
#define NXP_ELEMENT_IS_FUNCTION(x)	nxp_element_check_type((x), NXP_ELEMENT_TYPE_FUNCTION)


struct _NxpElementFunction {
    NxpElementVariable element;
    NxpElement *simple_args; /* A NxpElementList */
    GHashTable *named_args;
};

int	    nxp_element_function_get_type   (void);
void        nxp_element_function_type_init  (void);
NxpElement* nxp_element_function_new	    (NxpIdentifier	  *ident,
					     NxpElement		  *simple_args,
					     GHashTable		  *named_args);
NxpElement* nxp_element_function_new_simple (char		  *name,
					     NxpElement		  *args);

NxpElement* nxp_element_function_eval_from_name(char *name, NxpElement *args,
						NxpEvalContext *context,
						GError **error);

gboolean nxp_element_function_is(NxpElement *el, char *name, NxpEvalContext *context, GError **error);
GHashTable *nxp_named_args_ref(GHashTable *named_args);

#endif /* __FUNCTION_H__ */
