/* -*- Mode: C; c-file-style: "bsd"; -*- */
#ifndef __NXP_INT_H__
#define __NXP_INT_H__

#include "r.h"
#include <gmp.h>
#include "op_bindings.h"

#define NXP_ELEMENT_TYPE_INT	(nxp_element_int_get_type())

typedef struct _NxpElementInt 	NxpElementInt;
#include "element.h"

#define NXP_ELEMENT_INT(x)		(NXP_ELEMENT_TYPECAST(x, NXP_ELEMENT_TYPE_INT, NxpElementInt	))
#define NXP_ELEMENT_IS_INT(x)	        nxp_element_check_type((x), NXP_ELEMENT_TYPE_INT)

struct _NxpElementInt {
    NxpElementR element;
    mpz_t value;
};

int	    nxp_element_int_get_type	    (void);
void        nxp_element_int_type_init	    ();
void        nxp_element_int_operator_init   (NxpEvalContext  *context,
					     GError         **error);
NxpElement* nxp_element_int_new		    (nxp_int_t        value);
NxpElement* nxp_element_int_new_from_mpz    (mpz_t i);
NxpElement* nxp_element_int_sqrt_floor	    (NxpElement *self);
NxpElement* nxp_element_zero		    (void);

NxpElement* nxp_element_int_gcd		    (NxpElementInt *a, NxpElementInt *b,
					     NxpEvalContext *context,
					     GError **error);
NxpElement* nxp_element_int_inverse	    (NxpElementInt *b, NxpElementInt *p,
					     NxpEvalContext *context,
					     GError **error);
NxpElement* nxp_element_int_normalize	    (NxpElementInt *a, mpz_t p,
					     NxpEvalContext *context, GError **error);
nxp_int_t nxp_element_int_get_si	    (NxpElement *self, GError **error);
NxpElement* nxp_element_int_mul		    (NxpOp op, NxpElement *a, NxpElement *b, NxpEvalContext *context, GError **error);
#endif /* __NXP_INT_H__ */
