#ifndef __LIST_H__
#define __LIST_H__

#include "element.h"

typedef struct _NxpElementList	NxpElementList;

#define NXP_ELEMENT_TYPE_LIST (nxp_element_list_get_type())
#define NXP_ELEMENT_LIST(x)	(NXP_ELEMENT_TYPECAST(x, NXP_ELEMENT_TYPE_LIST,	NxpElementList	))
#define NXP_ELEMENT_IS_LIST(x)	        nxp_element_check_type((x), NXP_ELEMENT_TYPE_LIST)

struct _NxpElementList {
    NxpElement   element;
    GSList	*list;
    GSList	*last;
};

int	    nxp_element_list_get_type	    (void);
void        nxp_element_list_type_init	    ();
NxpElement* nxp_element_list_new	    (void);
NxpElement* nxp_element_list_new_simple	    (NxpElement *el);
NxpElement* nxp_element_list_new_from_list  (GSList *list);
NxpElement* nxp_element_list_extract	    (NxpElement *list,
					     int index1, int index2);
NxpElement* nxp_element_list_insert	    (NxpElement *list,
					     NxpElement *el,
					     gint position);
void nxp_element_list_append		    (NxpElement *el_list,
					     NxpElement *el);
void nxp_element_list_append_list	    (NxpElement *el_list,
					     NxpElement *el);
void nxp_element_list_prepend		    (NxpElement *el_args,
					     NxpElement *el);
int nxp_element_list_contains		    (NxpElement *el,
					     NxpElement *list,
					     NxpEvalContext *context,
					     GError **error);
int nxp_element_list_length		    (NxpElement *self);
gboolean nxp_element_list_same_content	    (NxpElement *list1,
					     NxpElement *list2,
					     NxpEvalContext *context,
					     GError **error);
#endif
