/* -*- Mode: C; c-file-style: "bsd"; -*- */
#ifndef __NXP_NUMBER_H__
#define __NXP_NUMBER_H__

#include "element.h"

typedef long long int 		nxp_int_t; /* NumeXP integer */
#define NXP_ELEMENT_TYPE_NUMBER	(nxp_element_number_get_type())

#define NXP_ELEMENT_NUMBER(x)	(NXP_ELEMENT_TYPECAST(x, NXP_ELEMENT_TYPE_NUMBER, NxpElementNumber ))
#define NXP_ELEMENT_IS_NUMBER(x)	        nxp_element_check_type((x), NXP_ELEMENT_TYPE_NUMBER)
#define NXP_ELEMENT_NUMBER_TYPE_INFO(x)	((NxpElementNumberTypeInfo *)NXP_ELEMENT(x)->type_info)

typedef struct _NxpElementNumber	    NxpElementNumber;
typedef struct _NxpElementNumberTypeInfo    NxpElementNumberTypeInfo;

struct _NxpElementNumber {
    NxpElement element;
};

struct _NxpElementNumberTypeInfo {
    NxpElementTypeInfo		     typeinfo;
    int (*compare_int)	    (NxpElementNumber *self, nxp_int_t nb);
    gboolean (*is_integer)	    (NxpElementNumber *self);
    NxpElement* (*opposed)	    (NxpElementNumber *self);
};

int	    nxp_element_number_get_type	    (void);
void        nxp_element_number_type_init    ();
int	    nxp_element_number_compare_int  (NxpElementNumber *self,
					     nxp_int_t nb);
int	    nxp_element_number_is_integer   (NxpElementNumber *self);
NxpElement* nxp_element_number_opposed	    (NxpElementNumber *self);
#endif /* __NXP_NUMBER_H__ */
