/* -*- Mode: C; c-file-style: "bsd"; -*- */
#ifndef __NXP_COMPLEX_H__
#define __NXP_COMPLEX_H__

#include <complex.h>
#include "element.h"
#include "vector.h"
#include "number.h"
#include "r.h"

#define NXP_ELEMENT_TYPE_COMPLEX    (nxp_element_complex_get_type())

typedef struct _NxpElementComplex 	NxpElementComplex;

typedef __complex__ long double 	nxp_complex_t; /* NumeXP complexes */

#define CXREAL(z) (__real__(z))	/* get real part from complex */
#define CXIMAG(z) (__imag__(z))	/* get imaginary part from complex */
#define CXCONJ(z) (~(z))	/* get conjugate of complex */

#define NXP_COMPLEX_REAL(z) _element_vector_index(NXP_ELEMENT_COMPLEX(z)->vector, 0)
#define NXP_COMPLEX_IMG(z) _element_vector_index(NXP_ELEMENT_COMPLEX(z)->vector, 1)

#define NXP_ELEMENT_COMPLEX(x)	(NXP_ELEMENT_TYPECAST(x, NXP_ELEMENT_TYPE_COMPLEX,	NxpElementComplex	))
#define NXP_ELEMENT_IS_COMPLEX(x)	        nxp_element_check_type(NXP_ELEMENT(x), NXP_ELEMENT_TYPE_COMPLEX)

struct _NxpElementComplex {
    NxpElementNumber element;
    NxpElementVector *vector;
};

int	    nxp_element_complex_get_type     (void);
NxpElement* nxp_element_complex_new_from_dbl (nxp_complex_t dbl);
NxpElement* nxp_element_complex_new_from_vector(NxpElement *vector);
NxpElement* nxp_element_complex_new          (NxpElement *real,
					      NxpElement *img);
void        nxp_element_complex_type_init     ();
nxp_complex_t	nxp_element_complex_get_value(NxpElementComplex *self);

#endif /* __NXP_COMPLEX_H__ */
