/* -*- Mode: C; c-file-style: "bsd"; -*- */
#ifndef __NXP_R_H__
#define __NXP_R_H__

#include "element.h"
#include "number.h"

#define NXP_ELEMENT_TYPE_R	(nxp_element_r_get_type())

#define NXP_ELEMENT_R(x)	(NXP_ELEMENT_TYPECAST((x), NXP_ELEMENT_TYPE_R, NxpElementR ))
#define NXP_ELEMENT_IS_R(x)	        nxp_element_check_type((x), NXP_ELEMENT_TYPE_R)
#define NXP_ELEMENT_R_TYPE_INFO(x)	((NxpElementRTypeInfo *)NXP_ELEMENT(x)->type_info)

typedef  long double 		nxp_real_t; /* NumeXP reals */
typedef struct _NxpElementR	    NxpElementR;
typedef struct _NxpElementRTypeInfo    NxpElementRTypeInfo;

struct _NxpElementR {
    NxpElementNumber element;
};

struct _NxpElementRTypeInfo {
    NxpElementNumberTypeInfo		     typeinfo;
    double (*get_value_as_double)   (NxpElementR *self);
    nxp_int_t (*get_value_as_int)   (NxpElementR *self);
};

#define	    nxp_element_r_compare_int(self,nb)	    nxp_element_number_compare_int(NXP_ELEMENT_NUMBER(self),(nb))
#define	    nxp_element_r_opposed(self)		    nxp_element_number_opposed(NXP_ELEMENT_NUMBER(self))
#define	    nxp_element_r_is_integer(self)	    nxp_element_number_is_integer(NXP_ELEMENT_NUMBER(self))

NxpElementType	nxp_element_r_get_type		    (void);
void		nxp_element_r_type_init		    ();
nxp_real_t	nxp_element_r_get_value_as_double   (NxpElementR     *self);
nxp_int_t	nxp_element_r_get_value_as_int	    (NxpElementR     *self);
NxpElement*	nxp_element_r_sqrt_floor	    (NxpElementR     *self,
						     GError	    **error);

#endif /* __NXP_R_H__ */
