/* -*- Mode: C; c-file-style: "bsd"; -*- */

#ifndef __REAL_H__
#define __REAL_H__

#include <gmp.h>
#include <mpfr.h>
#include "element.h"
#include "r.h"

#define EPS			0.00000001
#define NXP_ELEMENT_TYPE_REAL	(nxp_element_real_get_type())

typedef struct _NxpElementReal 	NxpElementReal;

#define NXP_ELEMENT_REAL(x)		(NXP_ELEMENT_TYPECAST(x, NXP_ELEMENT_TYPE_REAL,	NxpElementReal	))
#define NXP_ELEMENT_IS_REAL(x)	nxp_element_check_type((x), NXP_ELEMENT_TYPE_REAL)

struct _NxpElementReal {
    NxpElementR element;
    mpfr_t	value;
};

int	    nxp_element_real_get_type	    (void);
void        nxp_element_real_type_init	    ();
NxpElement* nxp_element_real_new	    (nxp_real_t   value);
NxpElement* nxp_element_real_new_from_mpfr  (mpfr_t  mpf);
nxp_real_t  nxp_element_real_get_double	    (NxpElement *self, GError **error);

#endif /* __REAL_H__ */
