/* -*- Mode: C; c-file-style: "bsd"; -*- */
#ifndef __NXP_TYPES_H__
#define __NXP_TYPES_H__

#include "number.h"
#include "real.h"
#include "nxp_complex.h"
#include "tree.h"
#include "number.h"
#include "r.h"
#include "int.h"
#include "frac.h"
#include "matrix.h"
#include "vector.h"
#include "list.h"
#include "function.h"
#include "nxp_string.h"
#include "variable.h"
#include "void.h"
#include "mpoly.h"
#include "container.h"


void nxp_types_init(GError **error);

// Initializers for relations
void nxp_element_frac_int_operator_init		(void);
void nxp_element_frac_real_operator_init	(void);
void nxp_element_real_int_operator_init		(void);

void nxp_element_vector_any_operator_init	(void);

void nxp_element_complex_r_operator_init	(void);
void nxp_element_variable_number_operator_init  (void);
void nxp_element_string_int_operator_init	(void);
void nxp_element_mpoly_variable_operator_init	(void);
void nxp_element_mpoly_number_operator_init	(void);
void nxp_element_matrix_vector_operator_init	(void);
void nxp_element_matrix_number_operator_init	(void);

void nxp_types_function_init(NxpEvalContext *context, GError **error);

#endif /* __NXP_TYPES_H__ */
