#ifndef __VARIABLES__
#define __VARIABLES__

#include <glib.h>

#include "namespace.h"
#include "identifier.h"
#include "element.h"
#include "types/list.h"


NxpElement*    nxp_variable_get                (NxpIdentifier  *ident,
						NxpEvalContext *context);
NxpDefinition* nxp_definition_get              (NxpIdentifier  *ident,
						NxpEvalContext *context);
void           nxp_user_variable_define        (NxpIdentifier  *ident,
						NxpElement     *value,
						NxpEvalContext *context,
						GError **error);
void           nxp_user_variable_define_simple (const char     *name,
						NxpElement     *value,
						NxpEvalContext *context,
						GError **error);
void           nxp_built_in_function_define    (const char     *name,
						gpointer        eval_func,
						gpointer        derive_func,
						gpointer        simplify_func,
						NxpEvalContext *context);
void           nxp_variable_undefine_at_top    (const char     *name,
						NxpEvalContext *context);
void           nxp_user_function_define        (NxpIdentifier  *ident,
						NxpElement     *list,
						NxpElement     *expression,
						NxpEvalContext *context,
						GError **error);






#define nxp_built_in_variable_define nxp_user_variable_define /* [TODO] */
#define nxp_built_in_variable_define_simple nxp_user_variable_define_simple


#endif





